package com.hzya.frame.deletedata;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
//import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.deletedata.cancelsignature.ApproveinfoCancelSignature;
import com.hzya.frame.deletedata.cancelsignature.JsonRootBeanCancelSignature;
import com.hzya.frame.deletedata.cancelsignature.QueryinfoCancelSignature;
import com.hzya.frame.deletedata.dao.DeleteU8cDataUtilDao;
import com.hzya.frame.deletedata.entity.DeleteU8cDataUtilEntity;
//import com.hzya.frame.plugin.lets.dao.ISoSaleinvoiceDao;
//import com.hzya.frame.plugin.lets.entity.SoSaleinvoiceEntity;
//import com.hzya.frame.plugin.lets.u8cdto.ReusltStrDto;
import com.hzya.frame.deletedata.vo.*;
import com.hzya.frame.split.SplitListByCountUtil;
import com.hzya.frame.ttxofs.dto.ofssaleorderoutsearch.HeaderDetailsDto;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
//import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：DeleteU8cDataUtil
 * @Date：2024/12/18 18:35
 * @Filename：DeleteU8cDataUtil
 */
@Component
public class DeleteU8cDataUtil {

    @Autowired
    private DeleteU8cDataUtilDao deleteU8cDataUtilDao;

    protected Logger logger = LogManager.getLogger(super.getClass());

    private static final Object LOCK_OBJECT = new Object();

    private static final Integer SPLIT_VAR = 1000;

    private static Integer MARK = 0;

    @PostConstruct
    public void init() {
        deleteTargetU8cData();
    }

    public void deleteTargetU8cData() {
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                synchronized (LOCK_OBJECT) {
                    if (MARK == 0) {
                        MARK = 1;
                        //删除销售发票
//                    deleteSoSaleinvoice();
                        //删除销售出库单
//                    deleteIcGeneralH();
                        //删除销售订单
//                    deleteSoSale();
                        //取消签字销售出库单 已测试
//                        cancelSignatureIcGeneralHV2("'0001A110000000001TH6', '0001A1100000000VKCOK'");
                        //销售出库单签字 已测试
//                        saleOutSign("'0001A110000000001TH6', '0001A1100000000VKCOK'");
                    }
                }
            }
        }, "U8C销售订单取消签字 2025-03-04");
        thread.start();
    }

    /**
     * 销售订单取消签字
     */
    public void cancelSignatureSoSale() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            deleteSoSaleVo.setFstatus(2L);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    List<String> stringList = new ArrayList<>();
                    stringList.add(deleteU8cDataUtilEntity.getVreceiptcode());

                    JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();

                    QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
                    queryinfoCancelSignature.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfoCancelSignature.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfoCancelSignature.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfoCancelSignature.setCode(stringList);

                    ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
                    approveinfoCancelSignature.setApprovid("tbadmin");

                    jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
                    jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(jsonRootBeanCancelSignature), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 销售订单取消签字
     * 每1000条取消签字，需要236秒，平均0.2秒一条
     */
    public void cancelSignatureSoSaleV2() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            deleteSoSaleVo.setFstatus(2L);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        List<String> stringList = new ArrayList<>();
//                        stringList.add(deleteU8cDataUtilEntity.getVreceiptcode());
//                        JsonRootBeanCancelSignature jsonRootBeanCancelSignature = new JsonRootBeanCancelSignature();
//                        QueryinfoCancelSignature queryinfoCancelSignature = new QueryinfoCancelSignature();
//                        queryinfoCancelSignature.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfoCancelSignature.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfoCancelSignature.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfoCancelSignature.setCode(stringList);
//                        ApproveinfoCancelSignature approveinfoCancelSignature = new ApproveinfoCancelSignature();
//                        approveinfoCancelSignature.setApprovid("tbadmin");
//                        jsonRootBeanCancelSignature.setApproveinfo(approveinfoCancelSignature);
//                        jsonRootBeanCancelSignature.setQueryinfo(queryinfoCancelSignature);


                        Map<String, Object> stringObjectMap = new HashMap<>();
                        stringObjectMap.put("approvid", "tbadmin");

                        Map<String, Object> stringObjectMap2 = new HashMap<>();
                        stringObjectMap2.put("date_begin", split[0]);
                        stringObjectMap2.put("date_end", split[0]);
                        stringObjectMap2.put("corp", split[1]);
                        stringObjectMap2.put("code", vreceiptcodeList);

                        Map<String, Object> stringObjectMap3 = new HashMap<>();
                        stringObjectMap3.put("approveinfo", stringObjectMap);
                        stringObjectMap3.put("queryinfo", stringObjectMap2);

                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/unapprove", JSON.toJSONString(stringObjectMap3), vreceiptcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售订单
     */
//    public void deleteSoSale() {
//        try {
//            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
//            deleteSoSaleVo.setDataSourceCode("lets_u8c");
//            deleteSoSaleVo.setFstatus(1L);
//            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleByDelete(deleteSoSaleVo);
//            logger.info("条数：{}", soSaleinvoiceEntities.size());
//            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
//                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
//                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);
//
//                    Deleteinfo deleteinfo = new Deleteinfo();
//                    deleteinfo.setCoperator("tbadmin");
//
//                    Queryinfo queryinfo = new Queryinfo();
//                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                    queryinfo.setCode(deleteU8cDataUtilEntity.getVreceiptcode());
//
//                    JsonRootBean jsonRootBean = new JsonRootBean();
//                    jsonRootBean.setDeleteinfo(deleteinfo);
//                    jsonRootBean.setQueryinfo(queryinfo);
//                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleorder/delete", JSON.toJSONString(jsonRootBean));
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    /**
     * 删除销售出库单
     */
    public void deleteIcGeneralH() {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByDelete(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setDeleteInfo(deleteinfo);
                    jsonRootBean.setQueryInfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售出库单
     */
    public void deleteIcGeneralHV2() {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByDelete(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");
//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());
//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setDeleteInfo(deleteinfo);
//                        jsonRootBean.setQueryInfo(queryinfo);

                        Map<String, Object> objectMap = new HashMap<>();
                        objectMap.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("deleteInfo", objectMap);
                        objectMap3.put("queryInfo", objectMap2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/delete", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售出库单取消签字
     */
    public void cancelSignatureIcGeneralH(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignature(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setUnsignInfo(deleteinfo);
                    jsonRootBean.setQueryInfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 销售出库单取消签字 V2
     */
    public void cancelSignatureIcGeneralHV2(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHByCancelSignature(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);

                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");
//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
//                        queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
//                        queryinfo.setBillcode(deleteU8cDataUtilEntity.getVbillcode());
//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setUnsignInfo(deleteinfo);
//                        jsonRootBean.setQueryInfo(queryinfo);

                        Map<String, Object> objectMap1 = new HashMap<>();
                        objectMap1.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("unsignInfo", objectMap1);
                        objectMap3.put("queryInfo", objectMap2);

//                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                        sendU8C("http://192.168.10.118:8088/u8cloud/api/ic/saleout/unsign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * 销售出库单签字
     */
    public void saleOutSign(String cbiztype) {
        try {
            DeleteIcGeneralHVo deleteIcGeneralHVo = new DeleteIcGeneralHVo();
            deleteIcGeneralHVo.setDataSourceCode("lets_u8c");
            deleteIcGeneralHVo.setCbiztype(cbiztype);
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.queryIcGeneralHBySign(deleteIcGeneralHVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);

                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vbillcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVbillcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

                        Map<String, Object> objectMap1 = new HashMap<>();
                        objectMap1.put("coperator", "tbadmin");
                        objectMap1.put("date_sign", split[0]);

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("billcode", vbillcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("signInfo", objectMap1);
                        objectMap3.put("queryInfo", objectMap2);

//                        sendU8C("http://39.170.109.90:8088/u8cloud/api/ic/saleout/sign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                        sendU8C("http://192.168.10.118:8088/u8cloud/api/ic/saleout/sign", JSON.toJSONString(objectMap3), vbillcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售发票
     */
    public void deleteSoSaleinvoice() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByDelete(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Deleteinfo deleteinfo = new Deleteinfo();
                    deleteinfo.setCoperator("tbadmin");

                    Queryinfo queryinfo = new Queryinfo();
                    queryinfo.setCorp(deleteU8cDataUtilEntity.getUnitcode());
                    queryinfo.setDate_begin(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setDate_end(deleteU8cDataUtilEntity.getDbilldate());
                    queryinfo.setCode(deleteU8cDataUtilEntity.getVreceiptcode());

                    JsonRootBean jsonRootBean = new JsonRootBean();
                    jsonRootBean.setDeleteinfo(deleteinfo);
                    jsonRootBean.setQueryinfo(queryinfo);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/delete", JSON.toJSONString(jsonRootBean), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除销售发票V2,速度提升版
     */
    public void deleteSoSaleinvoiceV2() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByDelete(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);
                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                        String key = entry.getKey();
                        List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                        List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                        String[] split = key.split("@@@@");

//                        Deleteinfo deleteinfo = new Deleteinfo();
//                        deleteinfo.setCoperator("tbadmin");

//                        Queryinfo queryinfo = new Queryinfo();
//                        queryinfo.setCorp(split[1]);
//                        queryinfo.setDate_begin(split[0]);
//                        queryinfo.setDate_end(split[0]);
//                        queryinfo.setCode(vreceiptcodeList);

//                        JsonRootBean jsonRootBean = new JsonRootBean();
//                        jsonRootBean.setDeleteinfo(deleteinfo);
//                        jsonRootBean.setQueryinfo(queryinfo);

                        Map<String, Object> objectMap = new HashMap<>();
                        objectMap.put("coperator", "tbadmin");

                        Map<String, Object> objectMap2 = new HashMap<>();
                        objectMap2.put("corp", split[1]);
                        objectMap2.put("date_begin", split[0]);
                        objectMap2.put("date_end", split[0]);
                        objectMap2.put("code", vreceiptcodeList);

                        Map<String, Object> objectMap3 = new HashMap<>();
                        objectMap3.put("deleteinfo", objectMap);
                        objectMap3.put("queryinfo", objectMap2);

                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/delete", JSON.toJSONString(objectMap3), vreceiptcodeList.size());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 2024年8月8日 10:54:48
     * 推送U8C销售订单方法
     *
     * @author liuyang
     */
    public void sendU8C(String url, String param, Integer number) throws Exception {
        logger.info("入参：" + param);
        long l = System.currentTimeMillis();
        String result = HttpRequest.post(url).header("usercode", "admin1").header("password", "f7fcde654e968541cc803c4b08c30abb").header("system", "lz1").header("trantype", "code").body(param)//表单内容
//                .timeout(900000000)//超时，毫秒，超时时间调整为1个小时
                .timeout(3600000).execute().body();
        long l1 = System.currentTimeMillis();
        long timeConsuming = l1 - l;
        logger.info("\n回参：" + result + " \n执行耗时：" + timeConsuming + "\n条数：" + number + " 每单耗时：" + (timeConsuming / 1000 / number));
//        JSONObject jsonObject = JSON.parseObject(result);
//        result = String.valueOf(jsonObject.get("attribute"));
//        System.out.println(result);
    }

    /**
     * 弃审应收单
     *
     * @author liuyang
     */
    public void abandoningReviewAccReceDoc() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.abandonmentAccountsReceivableDoc(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                    String dateString = sdf.format(new Date());

                    Map<String, String> stringStringMap = new HashMap<>();
                    stringStringMap.put("djbh", deleteU8cDataUtilEntity.getDjbh());//单据编码
                    stringStringMap.put("dwbm", deleteU8cDataUtilEntity.getUnitcode());//公司编码
                    stringStringMap.put("operatorid", "18846145294");//操作人编码
                    stringStringMap.put("operatedate", dateString);//操作日期

                    List<Map<String, String>> mapList = new ArrayList<>();
                    mapList.add(stringStringMap);

                    Map<String, List<Map<String, String>>> stringStringMap2 = new HashMap<>();
                    stringStringMap2.put("bills", mapList);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/unaudit", JSON.toJSONString(stringStringMap2), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 删除自由态的应收单
     *
     * @author liuyang
     */
    public void deleteReviewAccReceDoc() {
        try {
            DeleteSoSaleVo deleteSoSaleVo = new DeleteSoSaleVo();
            deleteSoSaleVo.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.abandonmentAccountsReceivableDocFreeState(deleteSoSaleVo);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    Map<String, String> stringStringMap = new HashMap<>();
                    stringStringMap.put("coperator", "tbadmin");

                    Map<String, String> stringStringMap2 = new HashMap<>();
                    stringStringMap2.put("dwbm", deleteU8cDataUtilEntity.getUnitcode());
                    stringStringMap2.put("djbh_from", deleteU8cDataUtilEntity.getDjbh());
                    stringStringMap2.put("djbh_to", deleteU8cDataUtilEntity.getDjbh());

                    Map<String, Map<String, String>> stringStringMap3 = new HashMap<>();
                    stringStringMap3.put("deleteinfo", stringStringMap);
                    stringStringMap3.put("queryinfo", stringStringMap2);
                    sendU8C("http://39.170.109.90:8088/u8cloud/api/arap/ys/delete", JSON.toJSONString(stringStringMap3), 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 弃审销售发票
     */
    public void abandonmentReviewSoSaleinvoice() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApproval(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                for (int i = 0; i < soSaleinvoiceEntities.size(); i++) {
                    DeleteU8cDataUtilEntity deleteU8cDataUtilEntity = soSaleinvoiceEntities.get(i);

                    try {
                        Map<String, String> stringStringMap = new HashMap<>();
                        stringStringMap.put("approvid", "tbadmin");

                        Map<String, String> stringStringMap2 = new HashMap<>();
                        stringStringMap2.put("corp", deleteU8cDataUtilEntity.getUnitcode());
                        stringStringMap2.put("code", deleteU8cDataUtilEntity.getVreceiptcode());
                        stringStringMap2.put("date_begin", deleteU8cDataUtilEntity.getDbilldate());
                        stringStringMap2.put("date_end", deleteU8cDataUtilEntity.getDbilldate());

                        Map<String, Map<String, String>> stringStringMap3 = new HashMap<>();
                        stringStringMap3.put("approveinfo", stringStringMap);
                        stringStringMap3.put("queryinfo", stringStringMap2);
                        sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/unapprove", JSON.toJSONString(stringStringMap3), 1);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            // 关闭线程池
//            executor.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 2025年2月11日 14:54:30
     * 弃审销售发票，速度提升版
     * 弃审367需要515秒，每条1.4秒，单条弃审大概需要1.8秒
     * 286 -> 397 1.3秒
     * 速度有一定的提升
     *
     * @author liuyang
     */
    public void abandonmentReviewSoSaleinvoiceV2() {
        try {
            DeleteU8cDataUtilEntity soSaleinvoiceEntity = new DeleteU8cDataUtilEntity();
            soSaleinvoiceEntity.setDataSourceCode("lets_u8c");
            List<DeleteU8cDataUtilEntity> soSaleinvoiceEntities = deleteU8cDataUtilDao.querySoSaleinvoiceByCancelApproval(soSaleinvoiceEntity);
            logger.info("条数：{}", soSaleinvoiceEntities.size());
            if (soSaleinvoiceEntities != null && soSaleinvoiceEntities.size() > 0) {
                List<List<DeleteU8cDataUtilEntity>> splitListByCount = SplitListByCountUtil.splitListByCount(soSaleinvoiceEntities, SPLIT_VAR);

                for (int i = 0; i < splitListByCount.size(); i++) {
                    List<DeleteU8cDataUtilEntity> deleteU8cDataUtilEntities = splitListByCount.get(i);
                    Map<String, List<DeleteU8cDataUtilEntity>> stringListMap = groupByDbilldate(deleteU8cDataUtilEntities);
                    try {
                        for (Map.Entry<String, List<DeleteU8cDataUtilEntity>> entry : stringListMap.entrySet()) {
                            String key = entry.getKey();
                            List<DeleteU8cDataUtilEntity> valueList = entry.getValue();
                            List<String> vreceiptcodeList = valueList.stream().map(DeleteU8cDataUtilEntity::getVreceiptcode).collect(Collectors.toList());

                            String[] split = key.split("@@@@");

                            Map<String, Object> stringStringMap = new HashMap<>();
                            stringStringMap.put("approvid", "tbadmin");

                            Map<String, Object> stringStringMap2 = new HashMap<>();
                            stringStringMap2.put("corp", split[1]);
                            stringStringMap2.put("code", vreceiptcodeList);
                            stringStringMap2.put("date_begin", split[0]);
                            stringStringMap2.put("date_end", split[0]);

                            Map<String, Map<String, Object>> stringStringMap3 = new HashMap<>();
                            stringStringMap3.put("approveinfo", stringStringMap);
                            stringStringMap3.put("queryinfo", stringStringMap2);
                            sendU8C("http://39.170.109.90:8088/u8cloud/api/so/saleinvoice/unapprove", JSON.toJSONString(stringStringMap3), vreceiptcodeList.size());
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            // 关闭线程池
//            executor.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 把相同单据日期+公司的发票汇总在一起
     *
     * @author liuyang
     */
    public static Map<String, List<DeleteU8cDataUtilEntity>> groupByDbilldate(List<DeleteU8cDataUtilEntity> entities) {
        Map<String, List<DeleteU8cDataUtilEntity>> resultMap = new HashMap<>();
        for (DeleteU8cDataUtilEntity entity : entities) {
            String dbilldate = entity.getDbilldate();
            String unitcode = entity.getUnitcode();
            // 如果 map 中不包含该日期，则创建一个新的列表
            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
        }
        return resultMap;
    }

    /**
     * 把相同单据日期+公司的发票汇总在一起
     *
     * @author liuyang
     */
//    public static Map<String, List<DeleteU8cDataUtilEntity>> groupByDbilldateV2(List<DeleteU8cDataUtilEntity> entities) {
//        Map<String, List<DeleteU8cDataUtilEntity>> resultMap = new HashMap<>();
//        for (DeleteU8cDataUtilEntity entity : entities) {
//            String dbilldate = entity.getDbilldate();
//            String unitcode = entity.getUnitcode();
//            // 如果 map 中不包含该日期，则创建一个新的列表
//            resultMap.computeIfAbsent(dbilldate + "@@@@" + unitcode, k -> new ArrayList<>()).add(entity);
//        }
//        return resultMap;
//    }

    // 定义最大线程数
//    private static final int MAX_THREADS = 100;

    // 创建一个固定大小的线程池
//    ExecutorService executor = Executors.newFixedThreadPool(MAX_THREADS);
}
