package com.hzya.frame.deletedata.dao;

import com.hzya.frame.basedao.dao.IBaseDao;
import com.hzya.frame.deletedata.entity.DeleteU8cDataUtilEntity;
import com.hzya.frame.deletedata.vo.DeleteArapDjzbVo;
import com.hzya.frame.deletedata.vo.DeleteIcGeneralHVo;
import com.hzya.frame.deletedata.vo.DeleteSoSaleVo;

import java.util.List;

/**
 * 报表授权表(report_accredit: table)表数据库访问层
 *
 * @author makejava
 * @since 2024-05-21 15:02:11
 */
public interface DeleteU8cDataUtilDao extends IBaseDao<DeleteU8cDataUtilEntity, String> {
    /**
     * 查询需要删除的销售发票
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> querySoSaleinvoiceByDelete(DeleteU8cDataUtilEntity soSaleinvoiceEntity) throws Exception;

    /**
     * 查询需要删除的销售出库单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> queryIcGeneralHByDelete(DeleteIcGeneralHVo deleteIcGeneralHVo) throws Exception;


    /**
     * 查询需要取消签字的销售出库单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> queryIcGeneralHByCancelSignature(DeleteIcGeneralHVo deleteIcGeneralHVo) throws Exception;

    /**
     * 查询需要取消签字的销售出库单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> queryIcGeneralHBySign(DeleteIcGeneralHVo deleteIcGeneralHVo) throws Exception;

    /**
     * 查询需要删除的销售订单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> querySoSaleByDelete(DeleteSoSaleVo deleteSoSaleVo) throws Exception;

    /**
     * 弃审应收单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> abandonmentAccountsReceivableDoc(DeleteSoSaleVo deleteSoSaleVo) throws Exception;

    /**
     * 自由态应收单
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> abandonmentAccountsReceivableDocFreeState(DeleteSoSaleVo deleteSoSaleVo) throws Exception;

    /**
     * 查询需要审批的销售发票
     *
     * @author liuyang
     */
    List<DeleteU8cDataUtilEntity> querySoSaleinvoiceByCancelApproval(DeleteU8cDataUtilEntity deleteU8cDataUtilEntity) throws Exception;

}