package com.hzya.frame.ttxofs.dto.ofsReceiptConfirmSearch;

import com.hzya.frame.ttxofs.basics.ReturnMessageBasics;
import com.hzya.frame.ttxofs.dto.ofsTransferOrderSearch.OFSAdjustOrderSearchResponse;
import com.hzya.frame.ttxofs.dto.ofspoorder.OfsPoOrderData;
import com.hzya.frame.ttxofs.dto.stock.StockinOrderSearchResponse;
import lombok.Data;

import java.util.List;

/**
 * Created by zydd on 2025-03-06 16:29
 */
@Data
public class OFSReceiptConfirmSearchResponse extends ReturnMessageBasics {


    private List<Order> data;

    @Data
    public class Order {
        private Header header;
        private List<Detail> details;
    }

    @Data
    public static class Header {
        /**
         * id
         */
        private String id;
        /**
         * 入库单
         */
        private String code;
        /**
         * 组织
         */
        private String clientCode;
        /**
         * 货主
         */
        private String companyCode;
        /**
         * 库存地点
         */
        private String facilityCode;
        /**
         * 入库单id
         */
        private String receiptId;
        /**
         * 入库单编码
         */
        private String receiptCode;
        /**
         * 关联订单id
         */
        private String refOrderId;
        /**
         * 关联订单
         */
        private String refOrderCode;
        /**
         * 入库类型
         */
        private String internalInstructionType;
        /**
         * 业务渠道
         */
        private String bizChannel;
        /**
         * 总数量
         */
        private String totalQty;
        /**
         * 处理状态
         */
        private String status;
        /**
         * 来源类型
         */
        private String sourceType;
        /**
         * 重试次数
         */
        private String retryCount;
        /**
         * 外部业务编码
         */
        private String outBizCode;
        /**
         * 确认类型
         */
        private String confirmType;
        /**
         * 创建时间
         */
        private String created;
        /**
         * 创建用户
         */
        private String createdBy;
        /**
         * 更新时间
         */
        private String lastUpdated;
        /**
         * 更新用户
         */
        private String lastUpdatedBy;
        /**
         * 数据版本
         */
        private String version;
        /**
         * 处理标记
         */
        private String processStamp;
        /**
         * 自定义字段1
         */
        private String userDef1;
        /**
         * 自定义字段2
         */
        private String userDef2;
        /**
         * 自定义字段3
         */
        private String userDef3;
        /**
         * 自定义字段4
         */
        private String userDef4;
        /**
         * 自定义字段5
         */
        private String userDef5;
        /**
         * 自定义字段6
         */
        private String userDef6;
        /**
         * 自定义字段7
         */
        private String userDef7;
        /**
         * 自定义字段8
         */
        private String userDef8;
        /**
         * 收货时间
         */
        private String receivedAt;
        /**
         * 收货人
         */
        private String receivedBy;
        /**
         * 异常类型
         */
        private String errorCode;
        /**
         * 异常描述
         */
        private String errorDesc;
        /**
         * 推送状态：0-未推送、1-已推送、2-推送失败
         */
        private String pushU8Status;
        /**
         * O采购入库单
         */
        private StockinOrderSearchResponse.StockinOrder ofsStockinOrder;
        /**
         * O采购订单
         */
        private OfsPoOrderData ofsOrderData;
    }

    @Data
    public static class Detail {
        /**
         * id
         */
        private String id;
        /**
         * 入库确认单id
         */
        private String receiptConfirmId;
        /**
         * 入库确认单
         */
        private String receiptConfirmCode;
        /**
         * 组织
         */
        private String clientCode;
        /**
         * 货主
         */
        private String companyCode;
        /**
         * 库存地点
         */
        private String facilityCode;
        /**
         * 入库单id
         */
        private String receiptId;
        /**
         * 入库单
         */
        private String receiptCode;
        /**
         * 入库单明细id
         */
        private String receiptDetailId;
        /**
         * 关联订单ID
         */
        private String refOrderId;
        /**
         * 关联订单
         */
        private String refOrderCode;
        /**
         * 关联订单明细id
         */
        private String refOrderDetailId;
        /**
         * sku编码
         */
        private String skuCode;
        /**
         * SKU名称
         */
        private String skuName;
        /**
         * 收货数量
         */
        private String receivedQty;
        /**
         * 在途数量
         */
        private String inTransQty;
        /**
         * 可退数量
         */
        private String returnableQty;
        /**
         * 单位
         */
        private String quantityUM;
        /**
         * 库存id
         */
        private String inventoryId;
        /**
         * 在库数量
         */
        private String onHandInvId;
        /**
         * 库存状态
         */
        private String inventorySts;
        /**
         * 批号
         */
        private String lot;
        /**
         * 批次
         */
        private String batch;
        /**
         * 入库日期
         */
        private String agingDate;
        /**
         * 失效日期
         */
        private String expirationDate;
        /**
         * 生产日期
         */
        private String mfgDate;
        /**
         * 批属性1
         */
        private String attribute1;
        /**
         * 批属性2
         */
        private String attribute2;
        /**
         * 批属性3
         */
        private String attribute3;
        /**
         * 批属性4
         */
        private String attribute4;
        /**
         * 总重量
         */
        private String totalWeight;
        /**
         * 总体积
         */
        private String totalVolume;
        /**
         * 总材积
         */
        private String totalVolumeWeight;
        /**
         * 重量单位
         */
        private String weightUM;
        /**
         * 体积单位
         */
        private String volumeUM;
        /**
         * 创建时间
         */
        private String created;
        /**
         * 创建用户
         */
        private String createdBy;
        /**
         * 更新时间
         */
        private String lastUpdated;
        /**
         * 更新用户
         */
        private String lastUpdatedBy;
        /**
         * 数据版本
         */
        private String version;
        /**
         * 处理标记
         */
        private String processStamp;
        /**
         * 自定义字段1
         */
        private String userDef1;
        /**
         * 自定义字段2
         */
        private String userDef2;
        /**
         * 自定义字段3
         */
        private String userDef3;
        /**
         * 自定义字段4
         */
        private String userDef4;
        /**
         * 自定义字段5
         */
        private String userDef5;
        /**
         * 自定义字段6
         */
        private String userDef6;
        /**
         * 自定义字段7
         */
        private String userDef7;
        /**
         * 自定义字段8
         */
        private String userDef8;
        /**
         * 备案编码
         */
        private String registerCode;
    }
}